//-----------------------------------------------------------
//
//-----------------------------------------------------------
class jSpectator extends UnrealSpectator;

struct spam
{
	var string	msg;
	var float	timestamp; // from Level.TimeSeconds
};

var		spam			SpamCheck[4];

exec function Admin(string CommandLine) { }

exec function Say( string Msg )
{
	local int i;
	local float TimeNow;
	local Pawn P;

	if ( Level.Game.AllowsBroadcast(self, Len(Msg)) )
	{
		if(JCoopGame(Level.Game).bNoSpam)
		{
			while(Mid(Msg, Len(Msg)-1, 1) == " ")
				Msg = Left(Msg, Len(Msg) - 1);

			TimeNow = Level.TimeSeconds;
			for(i=ArrayCount(SpamCheck)-1; i>=0; i--)
				if((TimeNow - SpamCheck[i].TimeStamp) > 15) // Spam aging
				{
					SpamCheck[i].Msg = "";
					SpamCheck[i].TimeStamp = 0;
				}

			// check for spam
			for(i=0; i<ArrayCount(SpamCheck); i++)
				if(Msg == SpamCheck[i].msg)
				{
					ClientMessage("Repetition: you just recently said that.");
					return;
				}

			// update spam array if not
			for(i=ArrayCount(SpamCheck)-1; i>0; i--)
				SpamCheck[i] = SpamCheck[i-1];
			SpamCheck[0].msg = Msg;
			SpamCheck[0].TimeStamp = TimeNow;
		}

		for( P=Level.PawnList; P!=None; P=P.nextPawn )
			if( P.bIsPlayer )
				P.TeamMessage( PlayerReplicationInfo, Msg, 'Say' );

		if(JCoopGame(Level.Game).bChatLog)
			log(PlayerReplicationInfo.PlayerName$": "$Msg, 'ChatLog');
	}
	return;
} // Say()

exec function SloMo(float T)
{
	if(!bAdmin) return;
	super.SloMo(T);
}

exec function SwitchCoopLevel( string URL )
{
	if(bAdmin)
		Level.ServerTravel( URL, true );
} // SwitchCoopLevel()

exec function SwitchLevel( string URL )
{
	if(bAdmin)
		Level.ServerTravel( URL, false );
} // SwitchLevel()

exec function TeamSay(string Msg)
{
	Say(Msg);
} // TeamSay()

exec function ghost() { }
exec function god() { }

function Typing (bool bTyping)
{
	JCPRI(PlayerReplicationInfo).bIsTyping = bTyping;
	Super.Typing(bTyping);
} // Typing()

defaultproperties
{
				PlayerReplicationInfoClass=Class'KNR.JCPRI'
				CollisionRadius=10.000000
				CollisionHeight=10.000000
}
